/*******************************************************************************
 * Copyright 2012 Thomas Letsch
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *******************************************************************************/
package com.googlecode.javaeeutils.jpa.manager;

import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


@Interceptor
@EnableEntityManager
public class EnableEntityManagerInterceptor {

    private static Log log = LogFactory.getLog(EnableEntityManagerInterceptor.class);

    @PersistenceContext
    EntityManager entityManager;

    public EnableEntityManagerInterceptor() {
    }

    @AroundInvoke
    public Object intercept(InvocationContext context) throws Exception {
        log.debug("Entering interceptor, em=" + entityManager);
        EntityManagerHelper.put(entityManager);
        Object result = context.proceed();
        EntityManagerHelper.reset();
        log.debug("Leaving interceptor, em=" + entityManager);
        return result;
    }
}